#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void soucet(int n, int a[][n],int b[][n], int result[][n]);
void soucin(int n, int a[][n],int b[][n], int result[][n]);
void generuj(int n, int a[][n]);
void vypis(int n, int a[][n]);
void soucetVektoru(int a[], int b[], int soucet[],int n);
int skalarniSoucin(int a[],int b[], int n);
int main()
{
    int n;

    printf("Zadejte rad matic:");
    scanf("%d",&n);

    int a[n][n],b[n][n],vysl[n][n];
    srand(time(NULL));
    generuj(n,a);
    generuj(n,b);
    printf("Matice A:\n");
    vypis(n,a);
    printf("Matice B:\n");
    vypis(n,b);
    soucet(n,a,b,vysl);
    printf("A+B:\n");
    vypis(n,vysl);
    soucin(n,a,b,vysl);
    printf("AxB:\n");
    vypis(n,vysl);

    return 0;
}
void generuj(int n, int a[][n])
{
   int i,j;
   for (i=0;i<n;i++)
   {
       for (j=0;j<n;j++)
       {
           a[i][j]=rand()%10;
       }
   }
}
void vypis(int n, int a[][n])
{
    int i,j;
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            printf("%3d",a[i][j]);
        }
        printf("\n");
    }
}
void soucet(int n, int a[][n],int b[][n], int result[][n])
{
    for(int i=0;i<n;i++){
        soucetVektoru(a[i],b[i],result[i],n);
    }
}
void soucetVektoru(int a[], int b[], int soucet[],int n)
{
    for(int i=0;i<n;i++)
    {
        soucet[i]=a[i]+b[i];
    }
}
void soucin(int n, int a[][n],int b[][n], int result[][n])
{
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            int bj[n];
            for(int k=0;k<n;k++)
            {
                bj[k]= b[k][j];
            }
            result[i][j]=skalarniSoucin(a[i],bj,n);
        }
    }

}
int skalarniSoucin(int a[],int b[], int n)
{
    int soucin =0;
    for(int i=0;i<n;i++)
    {
        soucin += a[i]*b[i];
    }
    return soucin;
}
